/***************************************************************************
 *   Copyright (C) 2007 by Claudio Scafuri, Giacomo Strangolino   *
 *   claudio@hyo   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// #include <TApplication>
// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#include <quapplication.h>
#include "tdklambda-genesis.h"
#include <X11/Xlib.h>
#include <QX11Info>

int main( int argc, char ** argv ) {

    QuApplication qu_app( argc, argv );//	TApplication is mapped into QuApplication. DBus connection is provided by cumbia dbus plugin	//	 ## added by qumbiaprojectwizard
    qu_app.setApplicationName("PowerSupplyTDKLambda");
    qu_app.setProperty("author", "Giacomo");
    qu_app.setProperty("mail", "giacomo.strangolino@elettra.trieste.it");
    qu_app.setProperty("phone", "375-8073");
    qu_app.setProperty("office", "T2PT025");
    qu_app.setProperty("hwReferent", "Stefano C."); /* name of the referent that provides the device server */

//     TUtil::instance()->setLoggingTarget(argv[0]);
//	QTango TUtil:: class is not present in cumbia	//	 ## added by qumbiaprojectwizard

    CumbiaPool *cu_p = new CumbiaPool();

    TdkLG *w = new TdkLG(cu_p, 0);
    QString title("pstdklambda-genesis");
    if (QApplication::arguments().size() > 1)
	    title = QApplication::arguments()[1].split('/').last(); /* solo il member */
    w->setWindowTitle(title);
    w->show();

    Display *disp = QX11Info::display();
    Window root_win = (Window) w->winId();
    XSetCommand(disp, root_win, argv, argc);

// exec application loop
    int ret = qu_app.exec();
    // delete resources and return
    delete w;

    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);
    return ret;
}

